/*
 * KlavMy - ovldanie pohybu a klikania myi pomocou klvesnice.
 * Copyright (C) 2008 Mat Sulr
 *
 * You can run this software, redistribute it and/or modify its source code.
 * Commercial use is prohibited (because of the limitation given by the
 * program used to create this application).
 *
 * This software is distributed WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you are unsure about legal details, see C++ Builder 6 Personal License
 * Terms by Borland Software Corporation.
 */

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "trayicon"
#pragma resource "*.dfm"
#pragma resource "xp.res" // WinXP vizualny styl

/* Konstanty */
#define PARAM "/klavmys_startup" // parameter aplikacie, ak sa spusta AutoRunom
const unsigned short PPT = 10; // Pixels Per Touch - pocet pixelov, o ktore sa
 // posunie kurzor pri jednom kratkom stlaceni klavesovej skratky

/* Premenne */
TfrmHlavny *frmHlavny; // hlavny formular
DWORD sprava_inst; // sprava, ktoru dostaneme po spusteni druhej instancie
void *stara_proc; // kvoli instancii
TIniFile *ini; // subor s nastaveniami
unsigned int vlavo_hore, hore, vpravo_hore, vlavo, vpravo, vlavo_dole, dole,
 vpravo_dole; // klavesove skratky na pohyb kurzora
unsigned int lavy_klik, pravy_klik, stredny_klik, drag_drop,
 aktiv; // ostatne skratky
bool je_aktivna = true; // je virtualna mys prave aktivna?
bool je_drag = false; // prebieha prave operacia Drag&Drop?
bool je_auto_spust = false; // je program spusteny AutoRunom?
//---------------------------------------------------------------------------

__fastcall TfrmHlavny::TfrmHlavny(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

/* Callback procedura (kvoli informacii, ze bola spustena 2. instancia) */
int CALLBACK NovaProc(HWND hwnd, DWORD uMsg, int paramW, int paramL)
{
  // ak bola spustena druha instancia
  if (uMsg == sprava_inst) {
    SendMessage(Application->Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
    SetForegroundWindow(Application->Handle);
    frmHlavny->Show();
    return 0;
  }
  return CallWindowProc((int (__stdcall *)()) stara_proc,
   hwnd, uMsg, paramW, paramL);
}

/* Aktivacia klavesovych skratiek na ovladanie mysi */
void TfrmHlavny::Aktivuj()
{
  /* Vo Windows sa zaregistruju globalne klavesove skratky pre jednotlive
     udalosti. ItemIndex prislusneho ComboBoxu sa zhoduje so suctom
     konstant modifikatorov MOD_xyz. Napr. MOD_ALT + MOD_SHIFT = 1 + 4 =
     = 5 = ItemIndex modifikatora Alt+Shift. */
  RegisterHotKey(Handle, vlavo_hore, cmbVlavoHore->ItemIndex,
   (char) hkVlavoHore->HotKey);
  RegisterHotKey(Handle, hore, cmbHore->ItemIndex,
   (char) hkHore->HotKey);
  RegisterHotKey(Handle, vpravo_hore, cmbVpravoHore->ItemIndex,
   (char) hkVpravoHore->HotKey);
  RegisterHotKey(Handle, vlavo, cmbVlavo->ItemIndex,
   (char) hkVlavo->HotKey);

  RegisterHotKey(Handle, vpravo, cmbVpravo->ItemIndex,
   (char) hkVpravo->HotKey);
  RegisterHotKey(Handle, vlavo_dole, cmbVlavoDole->ItemIndex,
   (char) hkVlavoDole->HotKey);
  RegisterHotKey(Handle, dole, cmbDole->ItemIndex,
   (char) hkDole->HotKey);
  RegisterHotKey(Handle, vpravo_dole, cmbVpravoDole->ItemIndex,
   (char) hkVpravoDole->HotKey);

  RegisterHotKey(Handle, lavy_klik, cmbLavyKlik->ItemIndex,
   (char) hkLavyKlik->HotKey);
  RegisterHotKey(Handle, pravy_klik, cmbPravyKlik->ItemIndex,
   (char) hkPravyKlik->HotKey);
  RegisterHotKey(Handle, stredny_klik, cmbStrednyKlik->ItemIndex,
   (char) hkStrednyKlik->HotKey);
  RegisterHotKey(Handle, drag_drop, cmbDragDrop->ItemIndex,
   (char) hkDragDrop->HotKey);
  RegisterHotKey(Handle, aktiv, cmbAktiv->ItemIndex,
   (char) hkAktiv->HotKey);
}
//---------------------------------------------------------------------------

/* Deaktivacia klavesovych skratiek na ovladanie mysi */
void TfrmHlavny::Deaktivuj()
{
  UnregisterHotKey(Handle, vlavo_hore);
  UnregisterHotKey(Handle, hore);
  UnregisterHotKey(Handle, vpravo_hore);
  UnregisterHotKey(Handle, vlavo);

  UnregisterHotKey(Handle, vpravo);
  UnregisterHotKey(Handle, vlavo_dole);
  UnregisterHotKey(Handle, dole);
  UnregisterHotKey(Handle, vpravo_dole);

  UnregisterHotKey(Handle, lavy_klik);
  UnregisterHotKey(Handle, pravy_klik);
  UnregisterHotKey(Handle, stredny_klik);
  UnregisterHotKey(Handle, drag_drop);
  // skratka 'aktiv' sa tu nedeaktivuje - mys by sa nedala opat aktivovat
}
//---------------------------------------------------------------------------

/* Nacitanie nastaveni z konfiguracneho INI suboru */
void TfrmHlavny::NacitajNastavenia()
{
  // modifikatory
  cmbVlavoHore->ItemIndex = ini->ReadInteger("Modif", "VlavoHore", 0);
  cmbHore->ItemIndex = ini->ReadInteger("Modif", "Hore", 0);
  cmbVpravoHore->ItemIndex = ini->ReadInteger("Modif", "VpravoHore", 0);
  cmbVlavo->ItemIndex = ini->ReadInteger("Modif", "Vlavo", 0);

  cmbVpravo->ItemIndex = ini->ReadInteger("Modif", "Vpravo", 0);
  cmbVlavoDole->ItemIndex = ini->ReadInteger("Modif", "VlavoDole", 0);
  cmbDole->ItemIndex = ini->ReadInteger("Modif", "Dole", 0);
  cmbVpravoDole->ItemIndex = ini->ReadInteger("Modif", "VpravoDole", 0);

  cmbLavyKlik->ItemIndex = ini->ReadInteger("Modif", "LavyKlik", 0);
  cmbPravyKlik->ItemIndex = ini->ReadInteger("Modif", "PravyKlik", 0);
  cmbStrednyKlik->ItemIndex = ini->ReadInteger("Modif", "StrednyKlik", 0);
  cmbDragDrop->ItemIndex = ini->ReadInteger("Modif", "DragDrop", 0);
  cmbAktiv->ItemIndex = ini->ReadInteger("Modif", "Aktiv", 3);

  // klavesy
  hkVlavoHore->HotKey = ini->ReadInteger("Klaves", "VlavoHore", VK_NUMPAD7);
  hkHore->HotKey = ini->ReadInteger("Klaves", "Hore", VK_NUMPAD8);
  hkVpravoHore->HotKey = ini->ReadInteger("Klaves", "VpravoHore", VK_NUMPAD9);
  hkVlavo->HotKey = ini->ReadInteger("Klaves", "Vlavo", VK_NUMPAD4);

  hkVpravo->HotKey = ini->ReadInteger("Klaves", "Vpravo", VK_NUMPAD6);
  hkVlavoDole->HotKey = ini->ReadInteger("Klaves", "VlavoDole", VK_NUMPAD1);
  hkDole->HotKey = ini->ReadInteger("Klaves", "Dole", VK_NUMPAD2);
  hkVpravoDole->HotKey = ini->ReadInteger("Klaves", "VpravoDole", VK_NUMPAD3);

  hkLavyKlik->HotKey = ini->ReadInteger("Klaves", "LavyKlik", VK_NUMPAD5);
  hkPravyKlik->HotKey = ini->ReadInteger("Klaves", "PravyKlik", VK_ADD);
  hkStrednyKlik->HotKey = ini->ReadInteger("Klaves", "StrednyKlik", VK_DECIMAL);
  hkDragDrop->HotKey = ini->ReadInteger("Klaves", "DragDrop", VK_NUMPAD0);
  hkAktiv->HotKey = ini->ReadInteger("Klaves", "Aktiv", 'M');

  // ine
  cbAutoSpustat->Checked = ini->ReadBool("Ine", "AutoSpust", false);
}
//---------------------------------------------------------------------------

/* Ulozenie nastaveni do konfiguracneho INI suboru */
void TfrmHlavny::UlozNastavenia()
{
  // modifikatory
  ini->WriteInteger("Modif", "VlavoHore", cmbVlavoHore->ItemIndex);
  ini->WriteInteger("Modif", "Hore", cmbHore->ItemIndex);
  ini->WriteInteger("Modif", "VpravoHore", cmbVpravoHore->ItemIndex);
  ini->WriteInteger("Modif", "Vlavo", cmbVlavo->ItemIndex);

  ini->WriteInteger("Modif", "Vpravo", cmbVpravo->ItemIndex);
  ini->WriteInteger("Modif", "VlavoDole", cmbVlavoDole->ItemIndex);
  ini->WriteInteger("Modif", "Dole", cmbDole->ItemIndex);
  ini->WriteInteger("Modif", "VpravoDole", cmbVpravoDole->ItemIndex);

  ini->WriteInteger("Modif", "LavyKlik", cmbLavyKlik->ItemIndex);
  ini->WriteInteger("Modif", "PravyKlik", cmbPravyKlik->ItemIndex);
  ini->WriteInteger("Modif", "StrednyKlik", cmbStrednyKlik->ItemIndex);
  ini->WriteInteger("Modif", "DragDrop", cmbDragDrop->ItemIndex);
  ini->WriteInteger("Modif", "Aktiv", cmbAktiv->ItemIndex);

  // klavesy
  ini->WriteInteger("Klaves", "VlavoHore", hkVlavoHore->HotKey);
  ini->WriteInteger("Klaves", "Hore", hkHore->HotKey);
  ini->WriteInteger("Klaves", "VpravoHore", hkVpravoHore->HotKey);
  ini->WriteInteger("Klaves", "Vlavo", hkVlavo->HotKey);

  ini->WriteInteger("Klaves", "Vpravo", hkVpravo->HotKey);
  ini->WriteInteger("Klaves", "VlavoDole", hkVlavoDole->HotKey);
  ini->WriteInteger("Klaves", "Dole", hkDole->HotKey);
  ini->WriteInteger("Klaves", "VpravoDole", hkVpravoDole->HotKey);

  ini->WriteInteger("Klaves", "LavyKlik", hkLavyKlik->HotKey);
  ini->WriteInteger("Klaves", "PravyKlik", hkPravyKlik->HotKey);
  ini->WriteInteger("Klaves", "StrednyKlik", hkStrednyKlik->HotKey);
  ini->WriteInteger("Klaves", "DragDrop", hkDragDrop->HotKey);
  ini->WriteInteger("Klaves", "Aktiv", hkAktiv->HotKey);

  // ine
  ini->WriteBool("Ine", "AutoSpust", cbAutoSpustat->Checked);
}
//---------------------------------------------------------------------------

/* Nastavenie AutoRunu v Registri */
void TfrmHlavny::NastavSpustanie() {
  /* K plnej ceste EXE suboru v uvodzovkach sa prida parameter urcujuci,
     ze program sa spusta AutoRunom. */
  String subor = "\"" + Application->ExeName + "\" " + PARAM;
  String kluc = "\\Software\\Microsoft\\Windows\\CurrentVersion\\Run";

  TRegistry *reg = new TRegistry();
  reg->OpenKey(kluc, true);
  if (cbAutoSpustat->Checked)
    reg->WriteString("KlavMys", subor);
  else
    reg->DeleteValue("KlavMys");
  delete reg;
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::FormCreate(TObject *Sender)
{
  // sprava a procedura pre informacie o instancii
  sprava_inst = RegisterWindowMessage("KlavMys sprava");
  stara_proc = (void *) SetWindowLong(Handle, GWL_WNDPROC, (LONG) (&NovaProc));

  ini = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
  NacitajNastavenia();
  NastavSpustanie();

  vlavo_hore = GlobalAddAtom("KlavMys vlavo hore");
  hore = GlobalAddAtom("KlavMys hore");
  vpravo_hore = GlobalAddAtom("KlavMys vpravo hore");
  vlavo = GlobalAddAtom("KlavMys vlavo");

  vpravo = GlobalAddAtom("KlavMys vpravo");
  vlavo_dole = GlobalAddAtom("KlavMys vlavo dole");
  dole = GlobalAddAtom("KlavMys dole");
  vpravo_dole = GlobalAddAtom("KlavMys vpravo dole");

  lavy_klik = GlobalAddAtom("KlavMys lavy klik");
  pravy_klik = GlobalAddAtom("KlavMys pravy klik");
  stredny_klik = GlobalAddAtom("KlavMys stredny klik");
  drag_drop = GlobalAddAtom("KlavMys drag and drop");
  aktiv = GlobalAddAtom("KlavMys aktiv");

  Aktivuj();
  btnPouzit->Enabled = false;

  /* Ak je program spustany AutoRunom, minimalizuje sa do tray ikony.
     Application->ShowMainForm = false je uz nastavene v klavmys.cpp. */
  if (ParamStr(1) != PARAM)
    frmHlavny->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::FormDestroy(TObject *Sender)
{
  SetWindowLong(Handle, GWL_WNDPROC, (LONG) stara_proc);

  Deaktivuj();
  UnregisterHotKey(Handle, aktiv);

  GlobalDeleteAtom(vlavo_hore);
  GlobalDeleteAtom(hore);
  GlobalDeleteAtom(vpravo_hore);
  GlobalDeleteAtom(vlavo);

  GlobalDeleteAtom(vpravo);
  GlobalDeleteAtom(vlavo_dole );
  GlobalDeleteAtom(dole);
  GlobalDeleteAtom(vpravo_dole);

  GlobalDeleteAtom(lavy_klik);
  GlobalDeleteAtom(pravy_klik);
  GlobalDeleteAtom(stredny_klik);
  GlobalDeleteAtom(drag_drop);
  GlobalDeleteAtom(aktiv);

  delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::aeUdalostiMessage(tagMSG &Msg, bool &Handled)
{
  if (Msg.message == WM_HOTKEY) {
    // reakcia na klaves. skratku docasnej aktivacie / deaktivacie
    if (Msg.wParam == aktiv) {
      je_aktivna = !je_aktivna;
      if (je_aktivna)
        Aktivuj();
      else
        Deaktivuj();
    }

    // reakcie na klavesove skratky - pohyb mysi a pod.
    if (je_aktivna) {
      TPoint Poz = Mouse->CursorPos;
      if (Msg.wParam == vlavo_hore)
        SetCursorPos(Poz.x - PPT, Poz.y - PPT);
      if (Msg.wParam == hore)
        SetCursorPos(Poz.x, Poz.y - PPT);
      if (Msg.wParam == vpravo_hore)
        SetCursorPos(Poz.x + PPT, Poz.y - PPT);
      if (Msg.wParam == vlavo)
        SetCursorPos(Poz.x - PPT, Poz.y);

      if (Msg.wParam == vpravo)
        SetCursorPos(Poz.x + PPT, Poz.y);
      if (Msg.wParam == vlavo_dole)
        SetCursorPos(Poz.x - PPT, Poz.y + PPT);
      if (Msg.wParam == dole)
        SetCursorPos(Poz.x, Poz.y + PPT);
      if (Msg.wParam == vpravo_dole)
        SetCursorPos(Poz.x + PPT, Poz.y + PPT);

      if (Msg.wParam == lavy_klik) {
        mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
        mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
      }
      if (Msg.wParam == pravy_klik) {
        mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
        mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
      }
      if (Msg.wParam == stredny_klik) {
        mouse_event(MOUSEEVENTF_MIDDLEDOWN, 0, 0, 0, 0);
        mouse_event(MOUSEEVENTF_MIDDLEUP, 0, 0, 0, 0);
      }
      if (Msg.wParam == drag_drop) {
        if (je_drag)
          mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0); // drop
        else
          mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0); // drag
        je_drag = !je_drag;
      }
    } // if (je_aktivna)
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::btnPouzitClick(TObject *Sender)
{
  btnPouzit->Enabled = false;

  Deaktivuj();
  UnregisterHotKey(Handle, drag_drop);
  Aktivuj();

  NastavSpustanie();
  UlozNastavenia();
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::hkVlavoHoreChange(TObject *Sender)
{
  // Alt+F4 = zatvorenie aplikacie
  if (dynamic_cast<THotKey *>(Sender)->HotKey == 32883)
    Application->Terminate();

  // zablokovanie skratky modifikator + F1, F2,...
  if (dynamic_cast<THotKey *>(Sender)->HotKey >= 256)
    dynamic_cast<THotKey *>(Sender)->HotKey = 0;

  btnPouzit->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::triIkonaClick(TObject *Sender)
{
  Show();
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::btnMinimalizovatClick(TObject *Sender)
{
  Hide();
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::cmbVpravoHoreChange(TObject *Sender)
{
  btnPouzit->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::cbAutoSpustatClick(TObject *Sender)
{
  btnPouzit->Enabled = true;
}
//---------------------------------------------------------------------------


